# GPT4Readability

[![License Badge](https://img.shields.io/github/license/loevlie/GPT4Readability)](https://github.com/loevlie/GPT4Readability/blob/main/LICENSE)
[![Issues Badge](https://img.shields.io/github/issues/loevlie/GPT4Readability)](https://github.com/loevlie/GPT4Readability/issues)
[![Pull Requests Badge](https://img.shields.io/github/issues-pr/loevlie/GPT4Readability)](https://github.com/loevlie/GPT4Readability/pulls)
[![Contributors Badge](https://img.shields.io/github/contributors/loevlie/GPT4Readability)](https://github.com/loevlie/GPT4Readability/graphs/contributors)
[![contributions welcome](https://img.shields.io/badge/contributions-welcome-brightgreen.svg?style=flat)](https://github.com/dwyl/esta/issues)

GPT4Readability is a powerful tool designed to automatically generate a README.md file and suggest code improvements for any Python code repository. It leverages advanced AI capabilities to analyze and interpret the codebase, providing comprehensive and accurate documentation.  Other than **this sentence** this readme file and this [suggestions file](https://github.com/loevlie/GPT4Readability/blob/main/suggestions.md) was generated by GPT4Readability using gpt-3.5-turbo.

## Main Functionalities

- Automatic generation of README.md file for Python codebases
- Suggestions for code improvements
- Integration with GPT-3.5 Turbo and GPT-4 models for enhanced analysis

## Installation

To install GPT4Readability, follow these steps:

1. Clone the repository:

   ```shell
   git clone https://github.com/loevlie/GPT4Readability.git
   ```

2. Navigate to the project directory:

   ```shell
   cd GPT4Readability
   ```

3. Install the required dependencies:

   ```shell
   pip install -e .
   ```

## Dependencies

GPT4Readability requires the following dependencies:

- langchain
- openai
- faiss-cpu
- tiktoken
- click
- tqdm

## Usage

GPT4Readability provides two main functionalities: generating a README.md file and suggesting code improvements. You can choose to use either of these functions or both.

To generate a README.md file, use the following command:

```shell
gpt4readability <path> --function readme --output_readme <output_name> --model <model>
```

Replace `<path>` with the root directory of the Python package you want to parse and generate a README for. `<output_name>` should be the desired filename for the generated README.md file. `<model>` specifies the model to use, either "gpt-3.5-turbo" or "gpt-4".

To suggest code improvements, use the following command:

```shell
gpt4readability <path> --function suggestions --output_suggestions <output_name> --model <model>
```

Replace `<path>` with the root directory of the Python package you want to analyze and suggest improvements for. `<output_name>` should be the desired filename for the generated suggestions.md file. `<model>` specifies the model to use, either "gpt-3.5-turbo" or "gpt-4".

## Authors

GPT4Readability is developed and maintained by Dennis Johan Loevlie. For any inquiries or support, please contact Dennis Johan Loevlie at loevliedenny@gmail.com.

## Contributing

Contributions to GPT4Readability are welcome! If you encounter any issues or have suggestions for improvements, please report them on the [GitHub Issues](https://github.com/loevlie/GPT4Readability/issues) page.

## Support

For support or assistance with GPT4Readability, please reach out to Dennis Johan Loevlie at loevliedenny@gmail.com.

## License

GPT4Readability is licensed under the [MIT License](https://github.com/loevlie/GPT4Readability/blob/main/LICENSE). Feel free to use, modify, and distribute this codebase as per the terms of the license.

## Acknowledgements

We would like to express our gratitude to the developers and contributors of the dependencies used in this project. Their hard work and dedication have made GPT4Readability possible.